;;; -*- Mode: Lisp -*-
;;; 2ch-browser-wrap.l --- 2ch-mode  browser.dll g

;; Copyright (C) 2001-2002 OHKUBO Hiroshi <konata_o@hotmail.com>

;; Author: OHKUBO Hiroshi <konata_o@hotmail.com>
;; Time-stamp: <2002/03/08 22:41:51 +0900>

;;; Commentary:

;; Key-bind:
;;
;;      [X]
;;              M-n             ̔ browser.dll ŕ\
;;              M-N              browser.dll \i͈͂́j
;;              TAB             ͎̔y[W̓X
;;                              browser.dll gpȂ甭\
;;              M-Down          ̔̓X
;;                              browser.dll gpȂ甭\
;;              M-Up            O̔̓X
;;                              browser.dll gpȂ甭\
;;
;;      [tH[]
;;              M-n              browser.dll ŕ\
;;              C-x C-c         ۑ browser.dll gpȂ\

;; Changes:
;;
;;      Fri, 08 Mar 2002 22:35:16 +0900
;;              EoCgRpCĂ悤ɏCB
;;
;;      Wed, 09 Jan 2002 13:34:54 +0900
;;              Ebrowserex g悤ɂB
;;              E2ch-0.0.0.8 [2001/12/14] ̃L[蓖ĕύXɒǏ]B
;;
;;      Tue, 18 Dec 2001 10:38:08 +0900
;;              En, N  M-n, M-N ɃL[oChύXB
;;
;;      Fri, 14 Dec 2001 15:03:19 +0900
;;              EvԂɎgĂ݂甼p܂Ƃɕ\ȂƂ
;;                C̂ŏo HTML  charset ǉB
;;

;; Memo:
;;
;;      E[2ch-0.0.0.8] (2002/01/01) œmFB
;;
;;      Ehtml o͑҂ wait. o͂ flush @킩Ȃ̂ŁA
;;        t@CgƂłĂ݂ĂB
;;
;;      E{ dat t@C璼ڃf[^ǂނׂ AA 邽
;;        ƂƂAĂȂB
;;

;;; Code:

(eval-when (:compile-toplevel :load-toplevel :execute)
  (require "2ch/macro"))
(require "2ch/thread")
(require "2ch/form")
(require "browserex")

(provide "2ch-browser-wrap")

(in-package "2ch")

(defvar work-html-files
  (list
   (concat (merge-pathnames ".2ch/work1.html" (si:system-root)))
   (concat (merge-pathnames ".2ch/work2.html" (si:system-root)))
   (concat (merge-pathnames ".2ch/work3.html" (si:system-root)))))
(defun get-work-html-file ()
  (car (push (pop work-html-files) (cdr (last work-html-files)))))

(defvar *special-string-encode-list* '(("&" . "&amp;")
                                       ( "\"" . "&quot;")
                                       ("<" . "&lt;")
                                       (">" . "&gt;")
;                                      ("," . "M")
                                       ("\n" . "<br>")
                                       (" " . "&nbsp;")
                                       ))
(defun thread-parse-special-strings-reverse (body)
  (dolist (sp *special-string-encode-list*)
    (setq body (substitute-string body (car sp) (cdr sp))))
  body)
(defun thread-view-current-in-browser-dll ()
  (interactive)
  (let ((article (thread-current-article))
        (work-html-file (get-work-html-file)))
    (when (thread-line-number article)
      (with-open-file (s work-html-file
                         :direction :output
                         :if-does-not-exist :create)
        (format s "~A~%" "<HTML>")
        (format s "~A~%" "  <HEAD>")
        (format s "~A~%" "    <META http-equiv=\"Content-Type\" content=\"text/html; charset=Shift-JIS\">")
        (format s "~A~%" "  </HEAD>")
        (format s "~A~%" "  <BODY>")
        (format s "~A" (thread-parse-special-strings-reverse
                        (thread-line-body article)))
        (format s "~A~%" "  </BODY>")
        (format s "~A~%" "</HTML>"))
      (refresh-screen)
;      (sleep-for 0.1)
      (bx:navigate work-html-file))))
(defun thread-view-range-in-browser-dll ()
  (interactive)
  (let* ((body "")
         articles
         (work-html-file (get-work-html-file)))
    (multiple-value-bind (beg end)
        (thread-get-range)
      (when (and beg end)
        (setq articles (thread-get-articles beg end))
        (dolist (article articles)
          (setq body (concat body (thread-line-body article)))))
      (with-open-file (s work-html-file
                         :direction :output
                         :if-does-not-exist :create)
        (format s "~A~%" "<HTML>")
        (format s "~A~%" "  <HEAD>")
        (format s "~A~%" "    <META http-equiv=\"Content-Type\" content=\"text/html; charset=Shift-JIS\">")
        (format s "~A~%" "  </HEAD>")
        (format s "~A~%" "  <BODY>")
        (format s "~A~03D - ~03D~A"
                "<DIV align=\"center\">" beg end "</DIV><HR><BR>")
        (format s "~A" (thread-parse-special-strings-reverse body))
        (format s "~A~%" "  </BODY>")
        (format s "~A~%" "</HTML>"))
      (refresh-screen)
;      (sleep-for 0.1); wait
      (bx:navigate work-html-file))))
(defun form-view-in-browser-dll ()
  (interactive)
  (save-excursion
    (let ((work-html-file (get-work-html-file)))
      (goto-line 8)
      (goto-bol)
      (with-open-file (s work-html-file
                         :direction :output
                         :if-does-not-exist :create)
        (format s "~A~%" "<HTML>")
        (format s "~A~%" "  <HEAD>")
        (format s "~A~%" "    <META http-equiv=\"Content-Type\" content=\"text/html; charset=Shift-JIS\">")
        (format s "~A~%" "  </HEAD>")
        (format s "~A~%" "  <BODY>")
        (format s "~A" (substitute-string
                        (buffer-substring (point) (point-max)) "\n" "<BR>"))
        (format s "~A~%" "  </BODY>")
        (format s "~A~%" "</HTML>"))
      (bx:navigate work-html-file))))

(defun thread-next-article-and-view-in-browser-dll ()
  (interactive)
  (thread-next-article)
  (if (bx:browser-open-p)
      (thread-view-current-in-browser-dll)))
(defun thread-next-article-obstinacy-and-view-in-browser-dll ()
  (interactive)
  (thread-next-article-obstinacy)
  (if (bx:browser-open-p)
      (thread-view-current-in-browser-dll)))
(defun thread-previous-article-and-view-in-browser-dll ()
  (interactive)
  (thread-previous-article)
  (if (bx:browser-open-p)
      (thread-view-current-in-browser-dll)))
(defun form-save-and-view-in-browser-dll ()
  (interactive)
  (form-save)
  (if (bx:browser-open-p)
      (form-view-in-browser-dll)))
(defun form-save-new-and-view-in-browser-dll ()
  (interactive)
  (form-save-new)
  (if (bx:browser-open-p)
      (form-view-in-browser-dll)))
(define-key *thread-map* #\M-n 'thread-view-current-in-browser-dll)
(define-key *thread-map* #\M-N 'thread-view-range-in-browser-dll)
(define-key *thread-map* #\TAB 'thread-next-article-and-view-in-browser-dll)
(define-key *thread-map* #\M-Down 'thread-next-article-obstinacy-and-view-in-browser-dll)
(define-key *thread-map* #\M-Up 'thread-previous-article-and-view-in-browser-dll)
(define-key *form-map* #\M-n 'form-view-in-browser-dll)
(define-key *form-map* '(#\C-x #\C-s) 'form-save-and-view-in-browser-dll)
(define-key *form-new-map* '(#\C-x #\C-s) 'form-save-new-and-view-in-browser-dll)

;;; 2ch-browser-wrap.l ends here
